//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@yL[COGtFNg v0.3b
//@@@by iuser/5145841j
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@[U[p[^

//@\[h ( 0FGtFNgKpʂ\A1FL[COp}bviG ` Gsj)
#define SHOW_KEYING_MAP 0

//@掿[hi 0FʓIȐeNX`g܂B1 dG[oꍇɎgpĉB
//@@@@@@@@ 1F_eNX`g܂BɖȂ΂gpj
#define HQ_MODE 1

//@񓧉߃[hi 0: ͂̂܂܏óA1: ͕sƂďo(񐄏)j
#define TRANSPARENT_MODE 0


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@`

//@|XgGtFNg錾
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

//@ANZTݒl擾
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha = MaterialDiffuse.a;

float Si : CONTROLOBJECT <string name="(self)"; string item="Si";>;
static const float Scale = Si * 0.1f;

//@XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = float2(0.5f, 0.5f) / ViewportSize;

//@_O^[Qbg̃NAl
float4 ClearColor = {0.0f, 0.0f, 0.0f, 0.0f};
float  ClearDepth = 1.0f;

#define Correction 1.0

//-----------------------------------------------------------------------------
// IWi̕`挋ʂL^邽߂̃_[^[Qbg
//
//-----------------------------------------------------------------------------
Texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = {1.0,1.0};
	int MipLevels = 1;
#if HQ_MODE
	string Format = "A16B16G16R16F";
#else
	string Format = "A8R8G8B8";
#endif
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU  = CLAMP;
	AddressV = CLAMP;
};

Texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = {1.0,1.0};
	string Format = "D24S8";
>;

//-----------------------------------------------------------------------------
// L[}bv
Texture2D KeyingMapRT: OFFSCREENRENDERTARGET <
	string Description = "o_postKeying ŐؔwɎgpItXN[^[Qbg\n"
		"White.fx w肵IuWFNg Black.fx w肵IuWFNgŐ؂蔲܂B";
	float4 ClearColor = {0,0,0,1};
	float ClearDepth = 1.0f;
#if HQ_MODE
	string Format = "R16F" ;
#else
	string Format = "X8R8G8B8";
#endif
	bool AntiAlias = true;
	string DefaultEffect = 
		"self = hide;"

		"*.x = Black.fx;"
		"*.pmd = White.fx;"
		"*.pmx = White.fx;";
>;

sampler KeyingMap = sampler_state {
	texture = <KeyingMapRT>;
	MinFilter = NONE;
	MagFilter = NONE;
	MipFilter = NONE;
	AddressU  = CLAMP;
	AddressV = CLAMP;
};


//-----------------------------------------------------------------------------
// Œ`
//-----------------------------------------------------------------------------
struct VS_OUTPUT
{
	float4 Pos			: POSITION;
	float2 TexCoord		: TEXCOORD0;
};

//-----------------------------------------------------------------------------
// KeyingMapɐ؂蔲
//-----------------------------------------------------------------------------

VS_OUTPUT VS_postKeying(float4 Pos:POSITION, float4 Tex:TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0; 

	Out.Pos = Pos;
	Out.TexCoord = Tex + ViewportOffset;
	
	return Out;
}

float4 PS_postKeying( float2 inTex: TEXCOORD0 ) : COLOR
{   
	float4 Color = tex2D(ScnSamp, inTex);
	float KeyingAlpha = tex2D(KeyingMap, inTex);

#if SHOW_KEYING_MAP
	return float4(KeyingAlpha, KeyingAlpha, KeyingAlpha, 1.0f);
#else
	float4 ColorOrg = Color;

  #if TRANSPARENT_MODE
	Color.a = KeyingAlpha == 0.0f ? 0.0f : 1.0f;
  #else
		Color.a = pow(KeyingAlpha, Scale * Correction);
  #endif

	return lerp(ColorOrg, Color, alpha);
#endif
}
////////////////////////////////////////////////////////////////////////////////////////////////

technique PostKeying <
	string Script = 
		"RenderColorTarget0=ScnMap;"
		"RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"ScriptExternal=Color;"

		//L[CO
		"RenderColorTarget0=;"
		"RenderDepthStencilTarget=;"

		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"

		"Pass=KeyingPass;"
	;
> {
	pass KeyingPass < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 VS_postKeying();
		PixelShader  = compile ps_2_0 PS_postKeying();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
